local _, addon = ...

-- functions
local C_Timer = C_Timer
local C_Timer_NewTimer = C_Timer.NewTimer
local CreateFrame = CreateFrame
local GetContainerItemID = GetContainerItemID
local GetContainerItemLink = GetContainerItemLink
local GetContainerNumSlots = GetContainerNumSlots
-- constants
local NUM_BAG_SLOTS = NUM_BAG_SLOTS
-- frames
-- libs

addon:RegisterCallback(addon.EVENT_BAG_SCAN_STARTED, function()
    addon:Print("Scanning for keystones in bags...")
end)

addon:RegisterCallback(addon.EVENT_BAG_SCAN_FINISHED, function(_, bagId, slotId, link)
    addon:Print(link and string.format("Found `%s`.", link) or "Could not find keystone in bags.")
    addon:SetCharacterKeystone(addon:GetCharacterKey(), link)
end)

do
    local scanDelay = 3
    local scanTimer
    local function scanCallback()
        addon:Fire(addon.EVENT_BAG_SCAN_STARTED)

        for bagId = 0, NUM_BAG_SLOTS do
            for slotId = 0, GetContainerNumSlots(bagId) do
                local itemId = GetContainerItemID(bagId, slotId)
                if 138019 == itemId then
                    local link = GetContainerItemLink(bagId, slotId)
                    addon:Fire(addon.EVENT_BAG_SCAN_FINISHED, bagId, slotId, link)
                    return
                end
            end
        end

        addon:Fire(addon.EVENT_BAG_SCAN_FINISHED)
    end

    local function onEvent()
        if scanTimer then
            scanTimer:Cancel()
        end

        scanTimer = C_Timer_NewTimer(scanDelay, scanCallback)
    end

    local f = CreateFrame("frame")
    f:SetScript("OnEvent", onEvent)
    f:RegisterEvent("BAG_UPDATE_DELAYED")
    f:RegisterEvent("CHALLENGE_MODE_COMPLETED")
    f:RegisterEvent("CHALLENGE_MODE_RESET")
    f:RegisterEvent("CHALLENGE_MODE_START")
    f:RegisterEvent("PLAYER_ENTERING_WORLD")

    function addon:BagScannerOnEvent()
        onEvent()
    end
end
