local _, addon = ...

-- functions
local format, split = string.format, string.split
local C_ChallengeMode = C_ChallengeMode
local C_ChallengeMode_GetMapInfo = C_ChallengeMode.GetMapInfo
local GetLocale = GetLocale
-- constants
-- frames
-- libs

addon.shorthandDungeonNames = GetLocale() ~= "enUS" and {} or {
    [197] = "EoA",
    [198] = "DHT",
    [199] = "BRH",
    [200] = "HoV",
    [206] = "Nelth",
    [207] = "Vault",
    [208] = "Maw",
    [209] = "Arcway",
    [210] = "CoS",
    [227] = "Lower Kara",
    [233] = "CoEN",
    [234] = "Upper Kara",
}

function addon:GetKeystoneInformation(link)
    local info = {split(":", link)}

    local instanceMapId = tonumber(info[2])
    local instanceName = select(1, C_ChallengeMode_GetMapInfo(instanceMapId))

    local level = tonumber(info[3])

    local isDepleted = 1 ~= tonumber(info[4])

    return link, instanceMapId, instanceName, level, isDepleted
end

function addon:GetKeystoneDisplayText(link, colour)
    local _, instanceMapId, instanceName, level, isDepleted = self:GetKeystoneInformation(link)

    local displayName = addon.options.useShorthand and addon.shorthandDungeonNames[instanceMapId] or instanceName

    if isDepleted then
        if colour then
            return format("|cff%s %s %s|r", "666666", displayName, level)
        end

        return format("%s %s (depl.)", displayName, level)
    end

    if colour then
        return format("|cff%s%s|r |cff%s%s|r", "ffffff", displayName, "00ff00", level)
    end

    return format("%s %s", displayName, level)
end
